searchNodes=[{"doc":"Documentation for Matrix Reloaded library. This a library is focusing only on updating, rearranging, getting/dropping row/column of a matrix. Also contains a few matrix operations like addition, subtraction or multiplication. Anyway if you need make fast operations on matrices, please use Matrex library. Each matrix is represented as a &quot;list of lists&quot; and functions mostly return Result . It means either tuple of {:ok, object} or {:error, &quot;msg&quot;} where object is either matrix or submatrix , vector or number . Numbering of row and column of matrix starts from 0 and goes to m - 1 and n - 1 where {m, n} is dimension (size) of matrix. Similarly for a row or column vector. In case of need, if you want to save your matrix to a file you can use package CSVlixir and then call function def save_csv ( matrix , file_name \\\\ &quot;matrix.csv&quot; ) do file_name |&gt; File . open ( [ :write ] , fn file -&gt; matrix |&gt; CSVLixir . write ( ) |&gt; Enum . each ( &amp; IO . write ( file , &amp;1 ) ) end ) end For example, you can choose where to save your matrix (in our case it's a tmp directory) MatrixReloaded.Matrix . new ( 3 , 1 ) |&gt; Result . and_then ( &amp; MatrixReloaded.Matrix . save_csv ( &amp;1 , &quot;/tmp/matrix.csv&quot; ) ) # {:ok, :ok} Examples: iex&gt; alias MatrixReloaded.Matrix iex&gt; up = Matrix . diag ( [ 2 , 2 , 2 ] , 1 ) iex&gt; down = Matrix . diag ( [ 2 , 2 , 2 ] , - 1 ) iex&gt; diag = Matrix . diag ( [ 3 , 3 , 3 , 3 ] ) iex&gt; band_mat = Result . and_then_x ( [ up , down ] , &amp; Matrix . add ( &amp;1 , &amp;2 ) ) iex&gt; band_mat = Result . and_then_x ( [ band_mat , diag ] , &amp; Matrix . add ( &amp;1 , &amp;2 ) ) { :ok , [ [ 3 , 2 , 0 , 0 ] , [ 2 , 3 , 2 , 0 ] , [ 0 , 2 , 3 , 2 ] , [ 0 , 0 , 2 , 3 ] ] } iex&gt; ones = Matrix . new ( 2 , 1 ) iex&gt; mat = Result . and_then_x ( [ band_mat , ones ] , &amp; Matrix . update ( &amp;1 , &amp;2 , { 1 , 1 } ) ) { :ok , [ [ 3 , 2 , 0 , 0 ] , [ 2 , 1 , 1 , 0 ] , [ 0 , 1 , 1 , 2 ] , [ 0 , 0 , 2 , 3 ] ] } iex&gt; mat |&gt; Result . and_then ( &amp; Matrix . get_row ( &amp;1 , 4 ) ) iex&gt; { :error , &quot;You can not get row from the matrix. The row number 4 is outside of matrix!&quot; } iex&gt; mat |&gt; Result . and_then ( &amp; Matrix . get_row ( &amp;1 , 3 ) ) iex&gt; { :ok , [ 0 , 0 , 2 , 3 ] } iex(4)&gt; mat |&gt; Result . and_then ( &amp; Matrix . drop_col ( &amp;1 , 3 ) ) { :ok , [ [ 3 , 2 , 0 ] , [ 2 , 3 , 2 ] , [ 0 , 2 , 3 ] , [ 0 , 0 , 2 ] ] }","ref":"MatrixReloaded.html","title":"MatrixReloaded","type":"module"},{"doc":"Provides a set of functions to work with matrices. Don't forget, numbering of row and column starts from 0 and goes to m - 1 and n - 1 where {m, n} is dimension (size) of matrix.","ref":"MatrixReloaded.Matrix.html","title":"MatrixReloaded.Matrix","type":"module"},{"doc":"Summation of two matrices. Sizes (dimensions) of both matrices must be same. Otherwise you get an error message. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Examples iex&gt; mat1 = { :ok , [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] } iex&gt; mat2 = MatrixReloaded.Matrix . new ( 3 , 1 ) iex&gt; Result . and_then_x ( [ mat1 , mat2 ] , &amp; MatrixReloaded.Matrix . add ( &amp;1 , &amp;2 ) ) { :ok , [ [ 2 , 3 , 4 ] , [ 5 , 6 , 7 ] , [ 8 , 9 , 10 ] ] }","ref":"MatrixReloaded.Matrix.html#add/2","title":"MatrixReloaded.Matrix.add/2","type":"function"},{"doc":"Concatenate matrices vertically. Both matrices must have same a column dimension. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; mat1 = MatrixReloaded.Matrix . diag ( [ 1 , 1 , 1 ] ) iex&gt; mat2 = MatrixReloaded.Matrix . diag ( [ 2 , 2 , 2 ] ) iex&gt; Result . and_then_x ( [ mat1 , mat2 ] , &amp; MatrixReloaded.Matrix . concat_col ( &amp;1 , &amp;2 ) ) { :ok , [ [ 1 , 0 , 0 ] , [ 0 , 1 , 0 ] , [ 0 , 0 , 1 ] , [ 2 , 0 , 0 ] , [ 0 , 2 , 0 ] , [ 0 , 0 , 2 ] ] }","ref":"MatrixReloaded.Matrix.html#concat_col/2","title":"MatrixReloaded.Matrix.concat_col/2","type":"function"},{"doc":"Concatenate matrices horizontally. Both matrices must have same a row dimension. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; mat1 = MatrixReloaded.Matrix . diag ( [ 1 , 1 , 1 ] ) iex&gt; mat2 = MatrixReloaded.Matrix . diag ( [ 2 , 2 , 2 ] ) iex&gt; Result . and_then_x ( [ mat1 , mat2 ] , &amp; MatrixReloaded.Matrix . concat_row ( &amp;1 , &amp;2 ) ) { :ok , [ [ 1 , 0 , 0 , 2 , 0 , 0 ] , [ 0 , 1 , 0 , 0 , 2 , 0 ] , [ 0 , 0 , 1 , 0 , 0 , 2 ] ] }","ref":"MatrixReloaded.Matrix.html#concat_row/2","title":"MatrixReloaded.Matrix.concat_row/2","type":"function"},{"doc":"Creates a square diagonal matrix with the elements of vector on the main diagonal or on lower/upper bidiagonal if diagonal number k is k &lt; 0 or 0 &lt; k . This number k must be integer. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; MatrixReloaded.Matrix . diag ( [ 1 , 2 , 3 ] ) { :ok , [ [ 1 , 0 , 0 ] , [ 0 , 2 , 0 ] , [ 0 , 0 , 3 ] ] } iex&gt; MatrixReloaded.Matrix . diag ( [ 1 , 2 , 3 ] , 1 ) { :ok , [ [ 0 , 1 , 0 , 0 ] , [ 0 , 0 , 2 , 0 ] , [ 0 , 0 , 0 , 3 ] , [ 0 , 0 , 0 , 0 ] ] }","ref":"MatrixReloaded.Matrix.html#diag/2","title":"MatrixReloaded.Matrix.diag/2","type":"function"},{"doc":"Drops the column or list of columns from the matrix. The column number (or column numbers) must be positive integer. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . drop_col ( mat , 2 ) { :ok , [ [ 0 , 0 , 0 ] , [ 0 , 0 , 2 ] , [ 0 , 0 , 4 ] , [ 0 , 0 , 0 ] ] } iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . drop_col ( mat , [ 0 , 1 ] ) { :ok , [ [ 0 , 0 ] , [ 1 , 2 ] , [ 3 , 4 ] , [ 0 , 0 ] ] }","ref":"MatrixReloaded.Matrix.html#drop_col/2","title":"MatrixReloaded.Matrix.drop_col/2","type":"function"},{"doc":"Drops the row or list of rows from the matrix. The row number (or row numbers) must be positive integer. Returns matrix. Example: iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . drop_row ( mat , 2 ) { :ok , [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 0 , 0 ] ] } iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . drop_row ( mat , [ 0 , 3 ] ) { :ok , [ [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] ] }","ref":"MatrixReloaded.Matrix.html#drop_row/2","title":"MatrixReloaded.Matrix.drop_row/2","type":"function"},{"doc":"Flip columns of matrix in the left-right direction (i.e. about a vertical axis). Example: iex&gt; mat = [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] iex&gt; MatrixReloaded.Matrix . flip_lr ( mat ) [ [ 3 , 2 , 1 ] , [ 6 , 5 , 4 ] , [ 9 , 8 , 7 ] ]","ref":"MatrixReloaded.Matrix.html#flip_lr/1","title":"MatrixReloaded.Matrix.flip_lr/1","type":"function"},{"doc":"Flip rows of matrix in the up-down direction (i.e. about a horizontal axis). Example: iex&gt; mat = [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] iex&gt; MatrixReloaded.Matrix . flip_ud ( mat ) [ [ 7 , 8 , 9 ] , [ 4 , 5 , 6 ] , [ 1 , 2 , 3 ] ]","ref":"MatrixReloaded.Matrix.html#flip_ud/1","title":"MatrixReloaded.Matrix.flip_ud/1","type":"function"},{"doc":"Gets a whole column from the matrix. By column number you can select the column which you want. Returns result, it means either tuple of {:ok, number} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . get_col ( mat , 3 ) { :ok , [ [ 0 ] , [ 2 ] , [ 4 ] , [ 0 ] ] }","ref":"MatrixReloaded.Matrix.html#get_col/2","title":"MatrixReloaded.Matrix.get_col/2","type":"function"},{"doc":"Gets a part column from the matrix. By index and positive number you can select the column and elements which you want. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . get_col ( mat , { 1 , 2 } , 2 ) { :ok , [ [ 1 ] , [ 3 ] ] }","ref":"MatrixReloaded.Matrix.html#get_col/3","title":"MatrixReloaded.Matrix.get_col/3","type":"function"},{"doc":"Gets an element from the matrix. By index you can select an element. Returns result, it means either tuple of {:ok, number} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . get_element ( mat , { 2 , 2 } ) { :ok , 3 }","ref":"MatrixReloaded.Matrix.html#get_element/2","title":"MatrixReloaded.Matrix.get_element/2","type":"function"},{"doc":"Gets a whole row from the matrix. By row number you can select the row which you want. Returns result, it means either tuple of {:ok, number} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . get_row ( mat , 1 ) { :ok , [ 0 , 0 , 1 , 2 ] }","ref":"MatrixReloaded.Matrix.html#get_row/2","title":"MatrixReloaded.Matrix.get_row/2","type":"function"},{"doc":"Gets a part row from the matrix. By index and positive number you can select the row and elements which you want. Returns result, it means either tuple of {:ok, number} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . get_row ( mat , { 2 , 1 } , 2 ) { :ok , [ 0 , 3 ] }","ref":"MatrixReloaded.Matrix.html#get_row/3","title":"MatrixReloaded.Matrix.get_row/3","type":"function"},{"doc":"Gets a submatrix from the matrix. By index you can select a submatrix. Dimension of submatrix is given by positive number (result then will be a square matrix) or tuple of two positive numbers (you get then a rectangular matrix). Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] iex&gt; MatrixReloaded.Matrix . get_submatrix ( mat , { 1 , 2 } , 2 ) { :ok , [ [ 1 , 2 ] , [ 3 , 4 ] ] } iex&gt; mat = [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 0 , 0 ] , [ 0 , 1 , 2 , 3 ] , [ 0 , 4 , 5 , 6 ] ] iex&gt; MatrixReloaded.Matrix . get_submatrix ( mat , { 2 , 1 } , { 3 , 3 } ) { :ok , [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ] }","ref":"MatrixReloaded.Matrix.html#get_submatrix/3","title":"MatrixReloaded.Matrix.get_submatrix/3","type":"function"},{"doc":"Creates a new matrix of the specified size. In case of positive number you get a squared matrix, for tuple {m, n} you get a rectangular matrix. For negative values you get an error message. All elements of the matrix are filled with the default value 0. This value can be changed. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Examples iex&gt; MatrixReloaded.Matrix . new ( 3 ) { :ok , [ [ 0 , 0 , 0 ] , [ 0 , 0 , 0 ] , [ 0 , 0 , 0 ] ] } iex&gt; MatrixReloaded.Matrix . new ( { 2 , 3 } , - 10 ) { :ok , [ [ - 10 , - 10 , - 10 ] , [ - 10 , - 10 , - 10 ] ] }","ref":"MatrixReloaded.Matrix.html#new/2","title":"MatrixReloaded.Matrix.new/2","type":"function"},{"doc":"Product of two matrices. If matrix A has a size n × p and matrix B has a size p × m then their matrix product A*B is matrix of size n × m . Otherwise you get an error message. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Examples iex&gt; mat1 = { :ok , [ [ 1 , 2 ] , [ 3 , 4 ] , [ 5 , 6 ] , [ 7 , 8 ] ] } iex&gt; mat2 = { :ok , [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ] } iex&gt; Result . and_then_x ( [ mat1 , mat2 ] , &amp; MatrixReloaded.Matrix . product ( &amp;1 , &amp;2 ) ) { :ok , [ [ 9 , 12 , 15 ] , [ 19 , 26 , 33 ] , [ 29 , 40 , 51 ] , [ 39 , 54 , 69 ] ] }","ref":"MatrixReloaded.Matrix.html#product/2","title":"MatrixReloaded.Matrix.product/2","type":"function"},{"doc":"Reshape vector or matrix. The row and col numbers must be positive number. By the row or col number you can change shape of matrix, respectively create new from vector. Returns result, it means either tuple of {:ok, vector | matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; 1 .. 10 |&gt; Enum . to_list |&gt; MatrixReloaded.Matrix . reshape ( 5 , 2 ) { :ok , [ [ 1 , 2 ] , [ 3 , 4 ] , [ 5 , 6 ] , [ 7 , 8 ] , [ 9 , 10 ] ] } iex&gt; MatrixReloaded.Matrix . new ( { 3 , 4 } ) |&gt; Result . map ( &amp; MatrixReloaded.Matrix . reshape ( &amp;1 , 2 , 6 ) ) { :ok , [ [ 0 , 0 , 0 , 0 , 0 , 0 , ] , [ 0 , 0 , 0 , 0 , 0 , 0 , ] ] }","ref":"MatrixReloaded.Matrix.html#reshape/3","title":"MatrixReloaded.Matrix.reshape/3","type":"function"},{"doc":"Schur product (or the Hadamard product) of two matrices. It produces another matrix where each element i, j is the product of elements i, j of the original two matrices. Sizes (dimensions) of both matrices must be same. Otherwise you get an error message. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Examples iex&gt; mat1 = { :ok , [ [ 1 , 2 , 3 ] , [ 5 , 6 , 7 ] ] } iex&gt; mat2 = { :ok , [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ] } iex&gt; Result . and_then_x ( [ mat1 , mat2 ] , &amp; MatrixReloaded.Matrix . schur_product ( &amp;1 , &amp;2 ) ) { :ok , [ [ 1 , 4 , 9 ] , [ 20 , 30 , 42 ] ] }","ref":"MatrixReloaded.Matrix.html#schur_product/2","title":"MatrixReloaded.Matrix.schur_product/2","type":"function"},{"doc":"The size (dimensions) of the matrix. Returns tuple of {row_size, col_size}. Example: iex&gt; MatrixReloaded.Matrix . new ( { 3 , 4 } ) |&gt; Result . map ( &amp; MatrixReloaded.Matrix . size ( &amp;1 ) ) { :ok , { 3 , 4 } }","ref":"MatrixReloaded.Matrix.html#size/1","title":"MatrixReloaded.Matrix.size/1","type":"function"},{"doc":"Subtraction of two matrices. Sizes (dimensions) of both matrices must be same. Otherwise you get an error message. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Examples iex&gt; mat1 = { :ok , [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] } iex&gt; mat2 = MatrixReloaded.Matrix . new ( 3 , 1 ) iex&gt; Result . and_then_x ( [ mat1 , mat2 ] , &amp; MatrixReloaded.Matrix . sub ( &amp;1 , &amp;2 ) ) { :ok , [ [ 0 , 1 , 2 ] , [ 3 , 4 , 5 ] , [ 6 , 7 , 8 ] ] }","ref":"MatrixReloaded.Matrix.html#sub/2","title":"MatrixReloaded.Matrix.sub/2","type":"function"},{"doc":"Transpose of matrix. Example: iex&gt; mat = [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] iex&gt; MatrixReloaded.Matrix . transpose ( mat ) [ [ 1 , 4 , 7 ] , [ 2 , 5 , 8 ] , [ 3 , 6 , 9 ] ]","ref":"MatrixReloaded.Matrix.html#transpose/1","title":"MatrixReloaded.Matrix.transpose/1","type":"function"},{"doc":"Updates the matrix by given a submatrix. The position of submatrix inside matrix is given by index {row_num, col_num} and dimension of submatrix. Size of submatrix must be less than or equal to size of matrix. Otherwise you get an error message. The values of indices start from 0 to matrix row size - 1 . Similarly for col size. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = MatrixReloaded.Matrix . new ( 4 ) iex&gt; mat |&gt; Result . and_then ( &amp; MatrixReloaded.Matrix . update ( &amp;1 , [ [ 1 , 2 ] , [ 3 , 4 ] ] , { 1 , 2 } ) ) { :ok , [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 1 , 2 ] , [ 0 , 0 , 3 , 4 ] , [ 0 , 0 , 0 , 0 ] ] }","ref":"MatrixReloaded.Matrix.html#update/3","title":"MatrixReloaded.Matrix.update/3","type":"function"},{"doc":"Updates column in the matrix by given a column vector. The column which you want to change is given by tuple {row_num, col_num} . Both values are non negative integers. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; { :ok , mat } = MatrixReloaded.Matrix . new ( 4 ) iex&gt; MatrixReloaded.Matrix . update_col ( mat , [ [ 1 ] , [ 2 ] , [ 3 ] ] , { 0 , 1 } ) { :ok , [ [ 0 , 1 , 0 , 0 ] , [ 0 , 2 , 0 , 0 ] , [ 0 , 3 , 0 , 0 ] , [ 0 , 0 , 0 , 0 ] ] }","ref":"MatrixReloaded.Matrix.html#update_col/3","title":"MatrixReloaded.Matrix.update_col/3","type":"function"},{"doc":"Updates the matrix by given a number. The position of element in matrix which you want to change is given by tuple {row_num, col_num} . Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = MatrixReloaded.Matrix . new ( 3 ) iex&gt; mat |&gt; Result . and_then ( &amp; MatrixReloaded.Matrix . update_element ( &amp;1 , - 1 , { 1 , 1 } ) ) { :ok , [ [ 0 , 0 , 0 ] , [ 0 , - 1 , 0 ] , [ 0 , 0 , 0 ] ] }","ref":"MatrixReloaded.Matrix.html#update_element/3","title":"MatrixReloaded.Matrix.update_element/3","type":"function"},{"doc":"Updates the matrix by given a submatrices. The positions (or locations) of these submatrices are given by list of indices. Index of the individual submatrices is tuple of two numbers. These two numbers are number row and number column of matrix where the submatrices will be located. All submatrices must have same size (dimension). Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; mat = MatrixReloaded.Matrix . new ( 5 ) iex&gt; sub_mat = MatrixReloaded.Matrix . new ( 2 , 1 ) iex&gt; positions = [ { 0 , 0 } , { 3 , 3 } ] iex&gt; [ mat , sub_mat ] |&gt; Result . and_then_x ( &amp; MatrixReloaded.Matrix . update_map ( &amp;1 , &amp;2 , positions ) ) { :ok , [ [ 1 , 1 , 0 , 0 , 0 ] , [ 1 , 1 , 0 , 0 , 0 ] , [ 0 , 0 , 0 , 0 , 0 ] , [ 0 , 0 , 0 , 1 , 1 ] , [ 0 , 0 , 0 , 1 , 1 ] ] }","ref":"MatrixReloaded.Matrix.html#update_map/3","title":"MatrixReloaded.Matrix.update_map/3","type":"function"},{"doc":"Updates row in the matrix by given a row vector (list) of numbers. The row which you want to change is given by tuple {row_num, col_num} . Both values are non negative integers. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Example: iex&gt; { :ok , mat } = MatrixReloaded.Matrix . new ( 4 ) iex&gt; MatrixReloaded.Matrix . update_row ( mat , [ 1 , 2 , 3 ] , { 3 , 1 } ) { :ok , [ [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 0 , 0 ] , [ 0 , 0 , 0 , 0 ] , [ 0 , 1 , 2 , 3 ] ] }","ref":"MatrixReloaded.Matrix.html#update_row/3","title":"MatrixReloaded.Matrix.update_row/3","type":"function"},{"doc":"","ref":"MatrixReloaded.Matrix.html#t:dimension/0","title":"MatrixReloaded.Matrix.dimension/0","type":"type"},{"doc":"","ref":"MatrixReloaded.Matrix.html#t:index/0","title":"MatrixReloaded.Matrix.index/0","type":"type"},{"doc":"","ref":"MatrixReloaded.Matrix.html#t:submatrix/0","title":"MatrixReloaded.Matrix.submatrix/0","type":"type"},{"doc":"","ref":"MatrixReloaded.Matrix.html#t:t/0","title":"MatrixReloaded.Matrix.t/0","type":"type"},{"doc":"Provides a set of functions to work with vectors. Mostly functions is written for a row vectors. So if you'll need a similar functionality even for a column vectors you can use transpose function on row vector.","ref":"MatrixReloaded.Vector.html","title":"MatrixReloaded.Vector","type":"module"},{"doc":"Addition of two a row vectors. These two vectors must have a same size. Otherwise you get an error message. Returns result, it means either tuple of {:ok, vector} or {:error, &quot;msg&quot;} . Examples iex&gt; MatrixReloaded.Vector . add ( [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ) { :ok , [ 5 , 7 , 9 ] }","ref":"MatrixReloaded.Vector.html#add/2","title":"MatrixReloaded.Vector.add/2","type":"function"},{"doc":"Create row vector of alternating sequence of numbers. Examples iex&gt; MatrixReloaded.Vector . row ( 5 ) |&gt; MatrixReloaded.Vector . alternate_seq ( 1 ) [ 1 , 0 , 1 , 0 , 1 ] iex&gt; MatrixReloaded.Vector . row ( 7 ) |&gt; MatrixReloaded.Vector . alternate_seq ( 1 , 3 ) [ 1 , 0 , 0 , 1 , 0 , 0 , 1 ]","ref":"MatrixReloaded.Vector.html#alternate_seq/3","title":"MatrixReloaded.Vector.alternate_seq/3","type":"function"},{"doc":"Create a column vector of the specified size. Default values of vector is set to 0 . This value can be changed. Returns list of list number. Examples iex&gt; MatrixReloaded.Vector . col ( 3 ) [ [ 0 ] , [ 0 ] , [ 0 ] ] iex&gt; MatrixReloaded.Vector . col ( 3 , 4 ) [ [ 4 ] , [ 4 ] , [ 4 ] ]","ref":"MatrixReloaded.Vector.html#col/2","title":"MatrixReloaded.Vector.col/2","type":"function"},{"doc":"Scalar product of two a row vectors. These two vectors must have a same size. Otherwise you get an error message. Returns result, it means either tuple of {:ok, number} or {:error, &quot;msg&quot;} . Examples iex&gt; MatrixReloaded.Vector . dot ( [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ) { :ok , 32 }","ref":"MatrixReloaded.Vector.html#dot/2","title":"MatrixReloaded.Vector.dot/2","type":"function"},{"doc":"Inner product of two a row vectors. It produces a row vector where each element i, j is the product of elements i, j of the original two row vectors. These two vectors must have a same size. Otherwise you get an error message. Returns result, it means either tuple of {:ok, vector} or {:error, &quot;msg&quot;} . Examples iex&gt; MatrixReloaded.Vector . inner_product ( [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ) { :ok , [ 4 , 10 , 18 ] }","ref":"MatrixReloaded.Vector.html#inner_product/2","title":"MatrixReloaded.Vector.inner_product/2","type":"function"},{"doc":"Multiply a vector by number. Examples iex&gt; MatrixReloaded.Vector . row ( 3 , 2 ) |&gt; MatrixReloaded.Vector . mult_by_num ( 3 ) [ 6 , 6 , 6 ] iex&gt; MatrixReloaded.Vector . col ( 3 , 2 ) |&gt; MatrixReloaded.Vector . mult_by_num ( 3 ) [ [ 6 ] , [ 6 ] , [ 6 ] ]","ref":"MatrixReloaded.Vector.html#mult_by_num/2","title":"MatrixReloaded.Vector.mult_by_num/2","type":"function"},{"doc":"Outer product of two a row vectors. It produces a matrix of dimension {m, n} where m and n are length (size) of row vectors. If input vectors aren't a row type you get an error message. Returns result, it means either tuple of {:ok, matrix} or {:error, &quot;msg&quot;} . Examples iex&gt; MatrixReloaded.Vector . outer_product ( [ 1 , 2 , 3 , 4 ] , [ 1 , 2 , 3 ] ) { :ok , [ [ 1 , 2 , 3 ] , [ 2 , 4 , 6 ] , [ 3 , 6 , 9 ] , [ 4 , 8 , 12 ] ] }","ref":"MatrixReloaded.Vector.html#outer_product/2","title":"MatrixReloaded.Vector.outer_product/2","type":"function"},{"doc":"Create a row vector of the specified size. Default values of vector is set to 0 . This value can be changed. Returns list of numbers. Examples iex&gt; MatrixReloaded.Vector . row ( 4 ) [ 0 , 0 , 0 , 0 ] iex&gt; MatrixReloaded.Vector . row ( 4 , 3.9 ) [ 3.9 , 3.9 , 3.9 , 3.9 ]","ref":"MatrixReloaded.Vector.html#row/2","title":"MatrixReloaded.Vector.row/2","type":"function"},{"doc":"The size of the vector. Returns a positive integer. Example: iex&gt; MatrixReloaded.Vector . row ( 3 ) |&gt; MatrixReloaded.Vector . size ( ) 3 iex&gt; MatrixReloaded.Vector . col ( 4 , - 1 ) |&gt; MatrixReloaded.Vector . size ( ) 4","ref":"MatrixReloaded.Vector.html#size/1","title":"MatrixReloaded.Vector.size/1","type":"function"},{"doc":"Subtraction of two a row vectors. These two vectors must have a same size. Otherwise you get an error message. Returns result, it means either tuple of {:ok, vector} or {:error, &quot;msg&quot;} . Examples iex&gt; MatrixReloaded.Vector . sub ( [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ) { :ok , [ - 3 , - 3 , - 3 ] }","ref":"MatrixReloaded.Vector.html#sub/2","title":"MatrixReloaded.Vector.sub/2","type":"function"},{"doc":"Convert (transpose) a row vector to column and vice versa. Examples iex&gt; MatrixReloaded.Vector . transpose ( [ 1 , 2 , 3 ] ) [ [ 1 ] , [ 2 ] , [ 3 ] ] iex(23)&gt; MatrixReloaded.Vector . transpose ( [ [ 1 ] , [ 2 ] , [ 3 ] ] ) [ 1 , 2 , 3 ]","ref":"MatrixReloaded.Vector.html#transpose/1","title":"MatrixReloaded.Vector.transpose/1","type":"function"},{"doc":"Update row vector by given a row subvector (list) of numbers or just by one number. The vector elements you want to change are given by the index. The index is a non-negative integer and determines the position of the element in the vector. Returns result, it means either tuple of {:ok, vector} or {:error, &quot;msg&quot;} . Example: iex&gt; vec = 0 .. 10 |&gt; Enum . to_list ( ) iex&gt; MatrixReloaded.Vector . update ( vec , [ 0 , 0 , 0 ] , 5 ) { :ok , [ 0 , 1 , 2 , 3 , 4 , 0 , 0 , 0 , 8 , 9 , 10 ] } iex&gt; vec = 0 .. 10 |&gt; Enum . to_list ( ) iex&gt; MatrixReloaded.Vector . update ( vec , 0 , 5 ) { :ok , [ 0 , 1 , 2 , 3 , 4 , 0 , 6 , 7 , 8 , 9 , 10 ] }","ref":"MatrixReloaded.Vector.html#update/3","title":"MatrixReloaded.Vector.update/3","type":"function"},{"doc":"Update row vector by given a row subvector (list) of numbers or by one number. The elements you want to change are given by the vector of indices. These indices must be a non-negative integers and determine the positions of the element in the vector. Returns result, it means either tuple of {:ok, vector} or {:error, &quot;msg&quot;} . Example: iex&gt; vec = 0 .. 10 |&gt; Enum . to_list ( ) iex&gt; MatrixReloaded.Vector . update_map ( vec , [ 0 , 0 ] , [ 2 , 7 ] ) { :ok , [ 0 , 1 , 0 , 0 , 4 , 5 , 6 , 0 , 0 , 9 , 10 ] } iex&gt; vec = 0 .. 10 |&gt; Enum . to_list ( ) iex&gt; MatrixReloaded.Vector . update_map ( vec , 0 , [ 2 , 7 ] ) { :ok , [ 0 , 1 , 0 , 3 , 4 , 5 , 6 , 0 , 8 , 9 , 10 ] }","ref":"MatrixReloaded.Vector.html#update_map/3","title":"MatrixReloaded.Vector.update_map/3","type":"function"},{"doc":"","ref":"MatrixReloaded.Vector.html#t:column/0","title":"MatrixReloaded.Vector.column/0","type":"type"},{"doc":"","ref":"MatrixReloaded.Vector.html#t:subvector/0","title":"MatrixReloaded.Vector.subvector/0","type":"type"},{"doc":"","ref":"MatrixReloaded.Vector.html#t:t/0","title":"MatrixReloaded.Vector.t/0","type":"type"}]